#include "lscm_unwrap.h"


// LOCALS
static LSCMUnwrap theLSCMUnwrap;
static LSCMUnwrapClassDesc LSCMUnwrapDesc;
ClassDesc2 *GetLSCMUnwrapDesc(){ return (&LSCMUnwrapDesc);}

// dummy function for the progress bar
DWORD WINAPI fn(LPVOID arg)
{
	return(0);
}


// Define out Function Published Block


//////////////////////////////////////////////////////////////////////////
// LSCMUnwrapIMP

static LSCMUnwrapIMP LSCMUnwrapFP (
	LSCMUnwrap_INTERFACE_ID, _T("ILSCMUnwrap"), 0, &LSCMUnwrapDesc, 0,
		fnIdUnwrap,			_T("unwrap"),		0, TYPE_VOID,	0, 1,	
		_T("object"), 0, TYPE_INODE,
		fnIdDrawSeams,			_T("drawSeams"),		0, TYPE_VOID,	0, 1,	
		_T("drawstate"), 0, TYPE_BOOL,
		fnIdSetFlagBit,		_T("setEdgeFlagBit"),		0, TYPE_VOID,	0, 1,
		_T("node"),	0,	TYPE_INT,
		fnIdSetSeamColor,	_T("setSeamColor"),		0, TYPE_VOID,	0, 1,
		_T("color"),	0,	TYPE_COLOR,
		fnIdGetFlag,		_T("getEdgeFlag"),		0, TYPE_INT,	0, 0,
		fnIdGetFlagBit,		_T("getEdgeFlagBit"),	0, TYPE_INT,	0, 0,
		fnIdGetSeamColor,	_T("getSeamColor"),		0, TYPE_COLOR,	0, 0,
		fnIdGetDrawZBuffered, _T("getDrawZBuffered"),	0, TYPE_BOOL, 0, 0,
		fnIdSetDrawZBuffered, _T("setDrawZBuffered"),	0, TYPE_VOID, 0, 1,
		_T("state"),	0,	TYPE_BOOL,
		fnIdGetPinVertices, _T("getPinVertices"),	0, TYPE_BOOL, 0, 0,
		fnIdSetPinVertices, _T("setPinVertices"),	0, TYPE_VOID, 0, 1,
		_T("state"),	0,	TYPE_BOOL,
		fnIdGetOnlySelected, _T("getOnlySelected"),	0, TYPE_BOOL, 0, 0,
		fnIdSetOnlySelected, _T("setOnlySelected"),	0, TYPE_VOID, 0, 1,
		_T("state"),	0,	TYPE_BOOL,
		fnIdGetThreshold, _T("getWeldThreshold"),	0, TYPE_FLOAT, 0, 0,
		fnIdSetThreshold, _T("setWeldThreshold"),	0, TYPE_VOID, 0, 1,
		_T("threshold"),	0,	TYPE_FLOAT,
		fnIdGetPackmax, _T("getPackmax"),	0, TYPE_FLOAT, 0, 0,
		fnIdSetPackmax, _T("setPackmax"),	0, TYPE_VOID, 0, 1,
		_T("scale"),	0,	TYPE_FLOAT,
		fnIdGetChannel, _T("getChannel"),	0, TYPE_INT, 0, 0,
		fnIdSetChannel, _T("setChannel"),	0, TYPE_VOID, 0, 1,
		_T("channel"),	0,	TYPE_INT,
		end
		);

void LSCMUnwrapIMP::Unwrap(INode *node)
{
	theLSCMUnwrap.DoUnwrap(node);	
}
void LSCMUnwrapIMP::DrawSeams(BOOL state)
{
	Interface *ip = theLSCMUnwrap.Max();
	if (!ip || state == theLSCMUnwrap.m_drawstate)
		return;

	theLSCMUnwrap.m_drawstate = state;

	if (state)
		ip->RegisterViewportDisplayCallback(FALSE, &theLSCMUnwrap.m_dcb);
	else
		ip->UnRegisterViewportDisplayCallback(FALSE, &theLSCMUnwrap.m_dcb);

	// forces clear cache
	theLSCMUnwrap.m_lastNumEdges = 0;
}
void LSCMUnwrapIMP::SetFlagBit(int flag){
	theLSCMUnwrap.m_edgebit = flag;
	theLSCMUnwrap.m_edgeflag = 1<<(flag-1);
}
int	LSCMUnwrapIMP::GetFlagBit(){
	return theLSCMUnwrap.m_edgebit;
}
int LSCMUnwrapIMP::GetFlag(){
	return theLSCMUnwrap.m_edgeflag;
}
void LSCMUnwrapIMP::SetSeamColor(Color *color){
	theLSCMUnwrap.m_seamcolor = *color;
}
Color* LSCMUnwrapIMP::GetSeamColor(){
	return &theLSCMUnwrap.m_seamcolor;
}
void LSCMUnwrapIMP::SetPinVertices(BOOL state){
	theLSCMUnwrap.m_pinvertices = state;
}
BOOL LSCMUnwrapIMP::GetPinVertices(){
	return theLSCMUnwrap.m_pinvertices;
}
void LSCMUnwrapIMP::SetOnlySelected(BOOL state){
	theLSCMUnwrap.m_onlyselected = state;
}
BOOL LSCMUnwrapIMP::GetOnlySelected(){
	return theLSCMUnwrap.m_onlyselected;
}
void LSCMUnwrapIMP::SetDrawZBuffered(BOOL state){
	theLSCMUnwrap.m_drawzbuffered = state;
}
BOOL LSCMUnwrapIMP::GetDrawZBuffered(){
	return theLSCMUnwrap.m_drawzbuffered;
}
void LSCMUnwrapIMP::SetThreshold(float state){
	theLSCMUnwrap.m_weldthresh = state;
}
float LSCMUnwrapIMP::GetThreshold(){
	return theLSCMUnwrap.m_weldthresh;
}
void LSCMUnwrapIMP::SetPackmax(float state){
	theLSCMUnwrap.m_packmax = state;
}
float LSCMUnwrapIMP::GetPackmax(){
	return theLSCMUnwrap.m_packmax;
}
void LSCMUnwrapIMP::SetChannel(int state){
	theLSCMUnwrap.m_channel = state;
}
int LSCMUnwrapIMP::GetChannel(){
	return theLSCMUnwrap.m_channel;
}
//////////////////////////////////////////////////////////////////////////
// LSCMDisplayCallback
void LSCMUnwrapDisplayCallback::Display(TimeValue t, ViewExp *vpt, int flags) 
{
	LSCMUnwrap	*pDc = &theLSCMUnwrap;
	Interface *ip = theLSCMUnwrap.Max();
	if (!ip)
		return;

	if (!ip->GetSelNodeCount()){
		return;
	}
	else{
		pDc->m_pNode = ip->GetSelNode(0);
	}

	if (!pDc->UpdateDrawCache()){
		return;
	}

	GraphicsWindow *gw = vpt->getGW();
	Point3 pt[4];
	Matrix3 tm = pDc->m_pNode->GetObjectTM(t);
	int savedLimits = gw->getRndLimits();

	int newLimits = savedLimits;
	if 	(theLSCMUnwrap.m_drawzbuffered)
		newLimits |= GW_Z_BUFFER;
	else
		newLimits &= ~GW_Z_BUFFER;
	gw->setRndLimits(newLimits & ~GW_ILLUM);

	gw->setTransform(tm);

	// Draw start point
	gw->setColor(LINE_COLOR,theLSCMUnwrap.m_seamcolor);

	for (int i = 0; i < pDc->m_edgeVerts.Count(); i+=5){
		pt[0] = pDc->m_edgeVerts[i];
		pt[1] = pDc->m_edgeVerts[i+1];
		gw->polyline(2, pt, NULL, NULL, 0, NULL);
		gw->marker(&pDc->m_edgeVerts[i+2],SM_CIRCLE_MRKR);
		gw->marker(&pDc->m_edgeVerts[i+3],SM_CIRCLE_MRKR);
		gw->marker(&pDc->m_edgeVerts[i+4],SM_CIRCLE_MRKR);
	}

	gw->setRndLimits(savedLimits);
}

void LSCMUnwrapDisplayCallback::GetViewportRect( TimeValue t, ViewExp *vpt, Rect *rect ) {
	// dont bother, we do fullscreen updates
	*rect += IPoint2(0,0);
	*rect += IPoint2(vpt->getGW()->getWinSizeX(),vpt->getGW()->getWinSizeY());
}


//////////////////////////////////////////////////////////////////////////
// LSCMUnwrap 

#define LSCM_EDGE_SEAM	m_edgeflag

LSCMUnwrap::LSCMUnwrap()
{
	m_packmax = 0.5f;
	m_drawzbuffered = TRUE;
	m_drawstate = FALSE;
	m_edgebit = 30;
	m_seamcolor = Color(0,1,0);
	m_edgeflag = 1<<29;
	m_pLastNode = NULL;
	m_pNode = NULL;
	m_weldthresh = 0.001f;
	m_pinvertices = FALSE;
	m_onlyselected = FALSE;
	m_channel = 1;
}

LSCMUnwrap::~LSCMUnwrap()
{
}

extern void unwrap_lscm(MNMesh &me, IUnwrapMod *newunwrap,  int channel, int edgeflag, BitArray *selfaces, BitArray *lockvertices, float thresh, TimeValue timev, float packmax);
void LSCMUnwrap::DoUnwrap(INode *node)
{
	Interface *ip = Max();
	if (!ip)
		return ;

	Object* lObj=node->GetObjectRef();

	IDerivedObject* dobj;

	if(lObj->SuperClassID() != GEN_DERIVOB_CLASS_ID)
	{
		dobj=CreateDerivedObject();
		dobj->ReferenceObject(lObj);
		node->SetObjectRef(dobj);
	}
	else
		dobj=(IDerivedObject*)lObj;

	Modifier *oldUnwrap = NULL;

	int numMods = dobj->NumModifiers() - 1;
	for( numMods; numMods >= 0; numMods--)
	{

		oldUnwrap = dobj->GetModifier(numMods);

		if( oldUnwrap->ClassID() == UNWRAP_CLASSID )
			break;
		else
			oldUnwrap = NULL;
	}

	theHold.Suspend();

	Modifier *newUnwrap=(Modifier*)ip->CreateInstance(OSM_CLASS_ID,UNWRAP_CLASSID);
	dobj->SetAFlag(A_LOCK_TARGET);
	dobj->AddModifier(newUnwrap);
	dobj->ClearAFlag(A_LOCK_TARGET);

	TimeValue time = ip->GetTime();
	Object *obj = node->EvalWorldState(time,FALSE).obj;

	if (!obj->IsSubClassOf(polyObjectClassID))
		return;

	unwrap_lscm(
		((PolyObject *)obj)->GetMesh(),
		(IUnwrapMod *) newUnwrap,
		m_channel,
		LSCM_EDGE_SEAM, 
		(m_onlyselected && oldUnwrap) ?		((IUnwrapMod *) oldUnwrap)->fnGetSelectedPolygons()	: NULL, 
		(m_pinvertices && oldUnwrap) ?		((IUnwrapMod *) oldUnwrap)->fnGetSelectedVerts()	: NULL, 
		m_weldthresh, 
		ip->GetTime(),
		m_packmax);
	

	theHold.Resume();

	newUnwrap->NotifyDependents(FOREVER,PART_TEXMAP,REFMSG_CHANGE);
	dobj->NotifyDependents(FOREVER,PART_TEXMAP,REFMSG_CHANGE);
	node->NotifyDependents(FOREVER,PART_TEXMAP,REFMSG_CHANGE);

	node->EvalWorldState(time);
	
	ip->SetCommandPanelTaskMode(TASK_MODE_MODIFY);
	ip->SelectNode(node);
	ip->ForceCompleteRedraw(0);

	((IUnwrapMod *) newUnwrap)->fnEdit();
}

int	LSCMUnwrap::UpdateDrawCache()
{
	Interface *ip = Max();
	if (!ip)
		return FALSE;

	Object *obj = m_pNode->EvalWorldState(ip->GetTime(),FALSE).obj;

	if (!obj->IsSubClassOf(polyObjectClassID))
		return FALSE;

	MNMesh &mesh = ((PolyObject *)obj)->GetMesh();
	BitArray	edges;
	mesh.getEdgesByFlag(edges,LSCM_EDGE_SEAM,0);

	// if nothing changed return
	if (m_lastedgeflag == LSCM_EDGE_SEAM && m_pNode == m_pLastNode && mesh.nume == m_lastNumEdges && (edges^m_lastEdges).NumberSet() == 0){
		return TRUE;
	}

	
	int	count = edges.NumberSet();

	m_pLastNode = m_pNode;
	m_lastEdges = edges;
	m_lastNumEdges = mesh.nume;
	m_lastedgeflag = LSCM_EDGE_SEAM;
	m_edgeVerts.SetCount(count*5);

	MNEdge *medge = mesh.e;
	count = 0;
	for (int i = 0; i < mesh.nume; medge++,i++){
		if (medge->GetFlag(LSCM_EDGE_SEAM)){
			m_edgeVerts[count+0] = mesh.v[medge->v1].p;
			m_edgeVerts[count+1] = mesh.v[medge->v2].p;

			m_edgeVerts[count+2] = m_edgeVerts[count+1] - m_edgeVerts[count+0];
			m_edgeVerts[count+3] = m_edgeVerts[count+2];
			m_edgeVerts[count+4] = m_edgeVerts[count+2];

			m_edgeVerts[count+2] = m_edgeVerts[count+2]*0.25f + m_edgeVerts[count+0];
			m_edgeVerts[count+3] = m_edgeVerts[count+3]*0.50f + m_edgeVerts[count+0];
			m_edgeVerts[count+4] = m_edgeVerts[count+4]*0.75f + m_edgeVerts[count+0];

			count+=5;
		}
	}

	return TRUE;
}

FPInterfaceDesc* LSCMUnwrap::GetDesc()
{
	return &LSCMUnwrapFP; 
}