/**********************************************************************
 *<
	FILE: LSCMUnwrap.h

	DESCRIPTION:	Includes for Plugins

	CREATED BY:

	HISTORY:

 *>	Copyright (c) 2000, All Rights Reserved.
 **********************************************************************/

#ifndef __LSCM_UNWRAP__H
#define __LSCM_UNWRAP__H

#include <Max.h>

#include "max_mem.h"

#include <modstack.h>
#include <iunwrap.h>
#include <istdplug.h>
#include <iFnPub.h>
#include <MAXScrpt\MAXScrpt.h>
#include <MAXScrpt\MAXObj.h>
#include <MAXScrpt\Listener.h>
#include <imacroscript.h>

#include <MNMesh.h>
#include <polyobj.h>
#include <guplib.h>



extern TCHAR *GetString(int id);
extern HINSTANCE hInstance;

#define LSCMUnwrap_CLASS_ID			Class_ID(0x52d114bc, 0x25452aff)
#define LSCMUnwrap_INTERFACE_ID		Interface_ID(0x52d114bc, 0x25452afe)


class LSCMUnwrap;

extern LSCMUnwrap theLSCMUnwrap;
extern TCHAR *GetString(int id);
extern HINSTANCE hInstance;


class LSCMUnwrapClassDesc : public ClassDesc2
{
public:
	int	IsPublic() { return (TRUE); }
	void *Create(BOOL loading = FALSE) { return (&theLSCMUnwrap); }
	const TCHAR *ClassName() { return (_T("LSCMUnwrap")); }
	SClass_ID SuperClassID() { return (GUP_CLASS_ID); }
	Class_ID ClassID() { return (LSCMUnwrap_CLASS_ID); }
	const TCHAR *Category() { return (_T("CrazyButcher")); }
	const TCHAR *InternalName() { return (_T("LSCMUnwrap")); }
	HINSTANCE HInstance() { return (hInstance); }
	virtual char* GetRsrcString( long t ){ return NULL; }
};

class ILSCMUnwrap : public FPStaticInterface {
public:
	virtual void Unwrap(INode *obj)	= 0;
	virtual void DrawSeams (BOOL state) = 0;
	virtual void SetSeamColor(Color *color) = 0;
	virtual Color* GetSeamColor() = 0;
	virtual void SetFlagBit(int flag) = 0;
	virtual int  GetFlagBit() = 0;
	virtual int  GetFlag() = 0;
	virtual void SetDrawZBuffered(BOOL state) = 0;
	virtual BOOL GetDrawZBuffered() = 0;
	virtual void SetPinVertices(BOOL state) = 0;
	virtual BOOL GetPinVertices() = 0;
	virtual void SetOnlySelected(BOOL state) = 0;
	virtual BOOL GetOnlySelected() = 0;
	virtual void SetThreshold(float t) = 0;
	virtual float GetThreshold() = 0;
	virtual void SetPackmax(float t) = 0;
	virtual float GetPackmax() = 0;
	virtual void SetChannel(int t) = 0;
	virtual int GetChannel() = 0;
};

enum{
	fnIdUnwrap,
	fnIdDrawSeams,
	fnIdGetFlag,
	fnIdSetFlagBit,
	fnIdGetFlagBit,
	fnIdSetSeamColor,
	fnIdGetSeamColor,
	fnIdSetDrawZBuffered,
	fnIdGetDrawZBuffered,
	fnIdSetPinVertices,
	fnIdGetPinVertices,
	fnIdSetOnlySelected,
	fnIdGetOnlySelected,
	fnIdSetThreshold,
	fnIdGetThreshold,
	fnIdSetPackmax,
	fnIdGetPackmax,
	fnIdSetChannel,
	fnIdGetChannel,
};

class LSCMUnwrapIMP :public ILSCMUnwrap
{
	DECLARE_DESCRIPTOR(LSCMUnwrapIMP) //Needed for static interfaces

	BEGIN_FUNCTION_MAP
		VFN_1(fnIdUnwrap, Unwrap, TYPE_INODE);
		VFN_1(fnIdDrawSeams, DrawSeams, TYPE_BOOL );
		VFN_1(fnIdSetFlagBit, SetFlagBit, TYPE_INT);
		FN_0 (fnIdGetFlagBit, TYPE_INT, GetFlagBit);
		VFN_1(fnIdSetSeamColor, SetSeamColor, TYPE_COLOR);
		FN_0 (fnIdGetSeamColor, TYPE_COLOR, GetSeamColor);
		FN_0 (fnIdGetFlag,TYPE_INT,GetFlag);
		VFN_1(fnIdSetDrawZBuffered,	SetDrawZBuffered, TYPE_BOOL);
		FN_0 (fnIdGetDrawZBuffered,	TYPE_BOOL, GetDrawZBuffered);
		VFN_1(fnIdSetPinVertices,	SetPinVertices, TYPE_BOOL);
		FN_0 (fnIdGetPinVertices,	TYPE_BOOL, GetPinVertices);
		VFN_1(fnIdSetOnlySelected,	SetOnlySelected, TYPE_BOOL);
		FN_0 (fnIdGetOnlySelected,	TYPE_BOOL, GetOnlySelected);
		VFN_1(fnIdSetThreshold,	SetThreshold, TYPE_FLOAT);
		FN_0 (fnIdGetThreshold,	TYPE_FLOAT, GetThreshold);
		VFN_1(fnIdSetPackmax,	SetPackmax, TYPE_FLOAT);
		FN_0 (fnIdGetPackmax,	TYPE_FLOAT, GetPackmax);
		VFN_1(fnIdSetChannel,	SetChannel, TYPE_INT);
		FN_0 (fnIdGetChannel,	TYPE_INT, GetChannel);
	END_FUNCTION_MAP

		//Functions from the published interface, ISuperUtility

		void Unwrap(INode *obj);
		void DrawSeams(BOOL state);
		void SetSeamColor(Color *color);
		Color* GetSeamColor();
		void SetFlagBit(int flag);
		int  GetFlagBit();
		int  GetFlag();
		void SetDrawZBuffered(BOOL state);
		BOOL GetDrawZBuffered();
		void SetPinVertices(BOOL state);
		BOOL GetPinVertices();
		void SetOnlySelected(BOOL state);
		BOOL GetOnlySelected();
		void SetThreshold(float t) ;
		float GetThreshold();
		void SetPackmax(float t) ;
		float GetPackmax();
		void SetChannel(int t);
		int GetChannel();
};


class LSCMUnwrapDisplayCallback : public ViewportDisplayCallback {
public:
	LSCMUnwrap *lscm;
	void SetSC(LSCMUnwrap *ls) { lscm = ls; }
	void Display(TimeValue t, ViewExp *vpt, int flags);
	void GetViewportRect( TimeValue t, ViewExp *vpt, Rect *rect );
	BOOL Foreground() { return TRUE; } 
};


class LSCMUnwrap : public GUP{
public:
	// functions
	LSCMUnwrap();
	~LSCMUnwrap();

	FPInterfaceDesc* GetDesc();

	int	 UpdateDrawCache();

	DWORD Start(){ return GUPRESULT_KEEP;}
	void  Stop(){};

	// values

	LSCMUnwrapDisplayCallback	m_dcb;

	int		m_edgebit;
	int		m_edgeflag;

	int		m_channel;
	int		m_drawstate;
	BOOL	m_drawzbuffered;
	BOOL	m_onlyselected;
	BOOL	m_pinvertices;
	Color	m_seamcolor;
	float	m_weldthresh;
	float	m_packmax;

	// DrawCache
	Tab<Point3>		m_edgeVerts;
	INode			*m_pNode;
	INode			*m_pLastNode;
	int				m_lastedgeflag;
	int				m_lastNumEdges;
	BitArray		m_lastEdges;


	void	DoUnwrap(INode *obj);
	
};




#endif // __LSCMUnwrap__H
